<template>
  <div class="h-100">
    <ob-table
      :columns="columns"
      :items="formDataArray"
      :show-add-button="true"
      :functional-panel="true"
      @add="addNewItem"
      @select="onSelection"
    >

    </ob-table>
    <ObModal
      ref="addModal"
      title="Добавление"
      size="xl"
      :is-show-controls="false"
    >
      <add-popup @save="save" :field-list="formDataArray"/>
    </ObModal>
    <edit-popup ref="editModal" :data-source="formData"/>
  </div>
</template>

<script>
  import ObModal from "common-components/src/obComponents/obModal"
  import tableLayoutMixin from "../../mixins/table-layout-mixin"
  import addPopup from "./modal/add"
  import editPopup from "./modal/editNew"
  import api from '@/api'
  import ObTable from "common-components/src/obComponents/obTable/index";
  import { dictionaryDefault } from '@/translations/ru/default';
  import { dictionary } from '@/translations/ru/settings__sb_settings__resource_cards';

  export default {
    name: "card-field",
    components: {ObTable, addPopup, editPopup, ObModal},
    mixins: [tableLayoutMixin],
    data() {
      return {
        propertyId: 'uuid',
        openAddPopup: false,
        openEditPopup: false,
        formData: {},
        formDataArray: [],
        rolesList: [],
        dictionaryRu: Object.assign(dictionary, dictionaryDefault)
      }
    },
    created () {
      this.fetchFields()
    },
    computed: {
      docTypes() {
        return this.dictionaryRu.doc_types;
      },
      systemTitle() {
        return this.dictionaryRu.editWindow.editSystemWindowTitle;
      },
      newTitle() {
        return this.dictionaryRu.editWindow.newWindowTitle;
      },
      columns() {
        return [
          {
            title: this.dictionaryRu.columns.title,
            key: 'title',
          },
          {
            title: this.dictionaryRu.columns.class,
            key: 'class.title',
            html: (data) =>  data.class && data.class.title
          },
          {
            title: this.dictionaryRu.columns.type,
            key: 'type.title',
            html: (data) =>  {
              return data.species && data.species.title
            }
          },
          {
            title: this.dictionaryRu.columns.subtype,
            key: 'subtype.title',
            html: (data) =>   {
              return data.subtype?data.subtype && data.subtype.title:''
            }
          },
          {
            title: this.dictionaryRu.columns.country,
            key: 'countries',
            html: (data) =>   {
              return data.countries && data.countries.map(c => c.name).join(', ')
            }
          },
          {
            title: this.dictionaryRu.columns.status,
            key: 'is_active',
            html: (data) => {
              if (data.deleted) {
                return '<div class="not-active">' + this.dictionaryRu.status.inactive + '</div>';
              }
              return '<div>' + this.dictionaryRu.status.active + '</div>';
            }
          }
        ]
      },
      systemReason() {
        return this.formData ? this.formData.system : false;
      },
      titleReason() {
        if(this.newStatus) {
          return this.newTitle;
        }
        if(this.systemReason) {
          return this.systemTitle;
        }
        return this.editTitle
      }
    },
    methods: {
      async fetchFields () {
        try {
          this.formDataArray = await api.card.fetchResource()

          let roles = await api.cardField.getRoles()
          this.rolesList = roles.content
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      async addNewItem() {
        this.$refs.addModal.open()
      },
      async save() {
        this.fetchFields();
        this.$refs.addModal.close()
      },
      async onSelection(data) {
        try {
          let risks = await api.card.getRiskResource(data.uuid)
          let resData = await api.card.getResourceDetail(data.uuid)
          this.formData = {...resData, ...{riskValues: risks}, uuid: data.uuid}
          this.$refs.editModal.open({data: this.formData})
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      getRoleTitle (code) {
        let role = this.rolesList.find(item => item.code === code)
        return role ? role.title : ''
      }
    }
  }
</script>

<style lang="scss">
  .color-error {
    color: $color-error;
  }
</style>
